#Include "..\..\source\Forms.bi"

#libpath "..\..\source\libs"
#Inclib "Forms"

#Include "..\..\source\TStatic.bas"
#Include "..\..\source\TButton.bas"
#Include "..\..\source\TCheckBox.bas"
#Include "..\..\source\TRadioButton.bas"
#Include "..\..\source\TGroupBox.bas"
#Include "..\..\source\TEdit.bas"
#Include "..\..\source\TComboBox.bas"
#Include "..\..\source\TListBox.bas"
#Include "..\..\source\TScrollBar.bas"
#Include "..\..\source\TMemo.bas"

using Colors

dim shared as TForm Form
dim shared as TButton Button
dim shared as TCheckBox CheckBox
dim shared as TRadioButton RadioButton
dim shared as TGroupBox GroupBox
dim shared as TEdit Edit
dim shared as TComboBox ComboBox
dim shared as TListBox ListBox
dim shared as TScrollBar ScrollBar
dim shared as TMemo Memo

declare sub FormCreate(Sender as TForm)
declare sub FormClose(Sender as TForm,byref CloseAction as integer)
declare sub FormPaint(Sender as TForm,dc as hdc)
Declare Sub ButtonClick(Sender as TButton)
declare sub NewClick(Sender as TMenuItem)
declare sub OpenClick(Sender as TMenuItem)

Form.onCreate=@FormCreate
Form.onClose=@FormClose
Form.onPaint=@FormPaint
Form.Parent=0
Form.Visible=1
'Form.BorderStyle=bstoolwindow

sub FormCreate(Sender as TForm)
    Sender.Height=550
    Sender.Width=Sender.Width+70
    Sender.Caption="Wellcome to guitk-s windows gui fb wrapper libary"
    Sender.Center=1
    
    static as TmenuItem mFile,mNew,mOpen '''always in sub use "static as" intead "dim as "
                                         '''when declare type variasble 
    
    mNew.Command=10 '''you must set commandid for menuitem, otherwise not trigger click event 
    mOpen.Command=11

    mFile.Caption="File"
    mNew.Caption="New"
    mOpen.Caption="Open"

    mFile.Add(mNew)
    mFile.Add(mOpen)
    Sender.Menu.Add(mFile)
    
    mNew.onClick=@NewClick
    mOpen.onClick=@OpenClick
    
    Button.Parent=Sender
    Button.Caption="Button"
    Button.onClick=@ButtonClick
    
    CheckBox.Parent=Sender
    CheckBox.Caption="CheckBox"
    CheckBox.Top=28
    CheckBox.Color=&hff00ff
    
    RadioButton.Parent=Sender
    RadioButton.Caption="RadioButton"
    RadioButton.Top=48
    RadioButton.Color=&hff
    
    GroupBox.Parent=Sender
    GroupBox.Caption="Button"
    GroupBox.Top=65
    GroupBox.Color=&hffff
    
    Edit.Parent=Sender
    Edit.Text="Edit"
    Edit.Top=120
    Edit.Color=&hff0000
    
    ComboBox.Parent=Sender
    ComboBox.Text="Text"
    ComboBox.Top=145
    ComboBox.Color=&h00ff0f
    ComboBox.Add "1"
    ComboBox.Add "2"
    ComboBox.Add "3"
    ComboBox.ItemIndex=1
    
    ListBox.Parent=Sender
    ListBox.Top=170
    ListBox.Color=&hf0f00f
    ListBox.Add "1"
    ListBox.Add "2"
    ListBox.Add "3"
    
    ScrollBar.Parent=Sender
    ScrollBar.Top=294
    ScrollBar.Style=1
    ScrollBar.Position=50
    
    Memo.Parent=Sender
    Memo.Top=324
    Memo.Color=&h00ff0f
    Memo.Add "1"
    Memo.Add "2"
    Memo.Add "3"
    
    Button.SetFocus
end Sub

sub FormPaint(Sender as TForm,dc as hdc)
    static as TBitmap Bitmap
    Bitmap.Transparency=1
    Bitmap.LoadFromFile("biglogo.bmp")
    Sender.Canvas.DrawTransparent(126,170,Bitmap)
    Bitmap.Transparency=0
    Bitmap.LoadFromFile("biglogo.bmp")
    Sender.Canvas.Draw(126,320,Bitmap)
    Sender.Canvas.Font.Color=0
    Sender.Canvas.TextOut(140,20,"Yhoooo...")
    Sender.Canvas.Font.Color=255
    Sender.Canvas.TextOut(190,20,"Yhoooo...",&HFFFF)
    Sender.Canvas.Pen.Color=0
    Sender.Canvas.Pen.Style=pssolid
    Sender.Canvas.Brush.Style=bssolid
    Sender.Canvas.Brush.Color=255
    Sender.Canvas.Rectangle(140,50,180,100)
    Sender.Canvas.Brush.Color=clBlue
    Sender.Canvas.Brush.Style=bsHatch
    Sender.Canvas.Brush.Hatch=hsDiagCross
    Sender.Canvas.Pen.Color=clred
    Sender.Canvas.Pen.Style=psdot
    Sender.Canvas.Rectangle(190,50,230,100)
    Sender.Canvas.Brush.Style=bsclear
    Sender.Canvas.Rectangle(190,110,230,160)
End Sub

sub NewClick(Sender as TMenuItem)
    MessageBox Form.Handle,Sender.Caption,"GuiTk-s",0
    Sender.onClick=0
end sub

sub OpenClick(Sender as TMenuItem)
    MessageBox Form.Handle,Sender.Caption,"GuiTk-s",0
end sub

Sub ButtonClick(Sender as TButton)
    MessageBox Sender.Parent->Handle,"You just click me !","GuiTk-s",0
End Sub

sub FormClose(Sender as TForm,byref CloseAction as integer)
    select case MessageBox(Sender.Handle,"Quit ?","GuiTk-s",MB_YESNO)
    case idyes
        PostQuitMessage(0)
        end
    case idno
        closeAction=0
    end select
end Sub

'''Main Loop---or you can made an application object 
dim as Msg Ms
while GetMessage(@Ms,0,0,0) > 0
    TranslateMessage(@Ms)
    DispatchMessage(@Ms)
wend
